package sun.java2d.opengl;

import sun.java2d.pipe.BufferedBufImgOps;
import java.awt.image.BufferedImageOp;
import java.awt.image.BufferedImage;
import sun.java2d.pipe.BufferedContext;
import java.awt.geom.AffineTransform;
import sun.java2d.pipe.Region;
import java.awt.Composite;
import sun.java2d.pipe.RenderBuffer;
import sun.java2d.SurfaceData;
import sun.java2d.pipe.RenderQueue;
import sun.java2d.loops.GraphicsPrimitiveMgr;
import sun.java2d.loops.CompositeType;
import sun.java2d.loops.GraphicsPrimitive;
import sun.java2d.loops.SurfaceType;

final class OGLBlitLoops
{
    private static final int OFFSET_SRCTYPE = 16;
    private static final int OFFSET_HINT = 8;
    private static final int OFFSET_TEXTURE = 3;
    private static final int OFFSET_RTT = 2;
    private static final int OFFSET_XFORM = 1;
    private static final int OFFSET_ISOBLIT = 0;
    
    OGLBlitLoops() {
    }
    
    static void register() {
        OGLSwToSurfaceBlit oglSwToSurfaceBlit = new OGLSwToSurfaceBlit(SurfaceType.IntArgbPre, 1);
        OGLSwToTextureBlit oglSwToTextureBlit = new OGLSwToTextureBlit(SurfaceType.IntArgbPre, 1);
        OGLSwToSurfaceTransform oglSwToSurfaceTransform = new OGLSwToSurfaceTransform(SurfaceType.IntArgbPre, 1);
        OGLSurfaceToSwBlit oglSurfaceToSwBlit = new OGLSurfaceToSwBlit(SurfaceType.IntArgbPre, 1);
        GraphicsPrimitiveMgr.register(new GraphicsPrimitive[] { new OGLSurfaceToSurfaceBlit(), new OGLSurfaceToSurfaceScale(), new OGLSurfaceToSurfaceTransform(), new OGLRTTSurfaceToSurfaceBlit(), new OGLRTTSurfaceToSurfaceScale(), new OGLRTTSurfaceToSurfaceTransform(), new OGLSurfaceToSwBlit(SurfaceType.IntArgb, 0), oglSurfaceToSwBlit, oglSwToSurfaceBlit, new OGLSwToSurfaceBlit(SurfaceType.IntRgb, 2), new OGLSwToSurfaceBlit(SurfaceType.IntRgbx, 3), new OGLSwToSurfaceBlit(SurfaceType.IntBgr, 4), new OGLSwToSurfaceBlit(SurfaceType.IntBgrx, 5), new OGLSwToSurfaceBlit(SurfaceType.ThreeByteBgr, 11), new OGLSwToSurfaceBlit(SurfaceType.Ushort565Rgb, 6), new OGLSwToSurfaceBlit(SurfaceType.Ushort555Rgb, 7), new OGLSwToSurfaceBlit(SurfaceType.Ushort555Rgbx, 8), new OGLSwToSurfaceBlit(SurfaceType.ByteGray, 9), new OGLSwToSurfaceBlit(SurfaceType.UshortGray, 10), new OGLGeneralBlit(OGLSurfaceData.OpenGLSurface, CompositeType.AnyAlpha, oglSwToSurfaceBlit), new OGLAnyCompositeBlit(OGLSurfaceData.OpenGLSurface, oglSurfaceToSwBlit, oglSurfaceToSwBlit, oglSwToSurfaceBlit), new OGLAnyCompositeBlit(SurfaceType.Any, null, oglSurfaceToSwBlit, oglSwToSurfaceBlit), new OGLSwToSurfaceScale(SurfaceType.IntRgb, 2), new OGLSwToSurfaceScale(SurfaceType.IntRgbx, 3), new OGLSwToSurfaceScale(SurfaceType.IntBgr, 4), new OGLSwToSurfaceScale(SurfaceType.IntBgrx, 5), new OGLSwToSurfaceScale(SurfaceType.ThreeByteBgr, 11), new OGLSwToSurfaceScale(SurfaceType.Ushort565Rgb, 6), new OGLSwToSurfaceScale(SurfaceType.Ushort555Rgb, 7), new OGLSwToSurfaceScale(SurfaceType.Ushort555Rgbx, 8), new OGLSwToSurfaceScale(SurfaceType.ByteGray, 9), new OGLSwToSurfaceScale(SurfaceType.UshortGray, 10), new OGLSwToSurfaceScale(SurfaceType.IntArgbPre, 1), new OGLSwToSurfaceTransform(SurfaceType.IntRgb, 2), new OGLSwToSurfaceTransform(SurfaceType.IntRgbx, 3), new OGLSwToSurfaceTransform(SurfaceType.IntBgr, 4), new OGLSwToSurfaceTransform(SurfaceType.IntBgrx, 5), new OGLSwToSurfaceTransform(SurfaceType.ThreeByteBgr, 11), new OGLSwToSurfaceTransform(SurfaceType.Ushort565Rgb, 6), new OGLSwToSurfaceTransform(SurfaceType.Ushort555Rgb, 7), new OGLSwToSurfaceTransform(SurfaceType.Ushort555Rgbx, 8), new OGLSwToSurfaceTransform(SurfaceType.ByteGray, 9), new OGLSwToSurfaceTransform(SurfaceType.UshortGray, 10), oglSwToSurfaceTransform, new OGLGeneralTransformedBlit(oglSwToSurfaceTransform), new OGLTextureToSurfaceBlit(), new OGLTextureToSurfaceScale(), new OGLTextureToSurfaceTransform(), oglSwToTextureBlit, new OGLSwToTextureBlit(SurfaceType.IntRgb, 2), new OGLSwToTextureBlit(SurfaceType.IntRgbx, 3), new OGLSwToTextureBlit(SurfaceType.IntBgr, 4), new OGLSwToTextureBlit(SurfaceType.IntBgrx, 5), new OGLSwToTextureBlit(SurfaceType.ThreeByteBgr, 11), new OGLSwToTextureBlit(SurfaceType.Ushort565Rgb, 6), new OGLSwToTextureBlit(SurfaceType.Ushort555Rgb, 7), new OGLSwToTextureBlit(SurfaceType.Ushort555Rgbx, 8), new OGLSwToTextureBlit(SurfaceType.ByteGray, 9), new OGLSwToTextureBlit(SurfaceType.UshortGray, 10), new OGLGeneralBlit(OGLSurfaceData.OpenGLTexture, CompositeType.SrcNoEa, oglSwToTextureBlit) });
    }
    
    private static int createPackedParams(boolean b, boolean b2, boolean b3, boolean b4, int n, int n2) {
        return n2 << 16 | n << 8 | (b2 ? 1 : 0) << 3 | (b3 ? 1 : 0) << 2 | (b4 ? 1 : 0) << 1 | (b ? 1 : 0) << 0;
    }
    
    private static void enqueueBlit(RenderQueue renderQueue, SurfaceData surfaceData, SurfaceData surfaceData2, int x, int x2, int x3, int x4, int x5, double x6, double x7, double x8, double x9) {
        RenderBuffer buffer = renderQueue.getBuffer();
        renderQueue.ensureCapacityAndAlignment(72, 24);
        buffer.putInt(31);
        buffer.putInt(x);
        buffer.putInt(x2).putInt(x3);
        buffer.putInt(x4).putInt(x5);
        buffer.putDouble(x6).putDouble(x7);
        buffer.putDouble(x8).putDouble(x9);
        buffer.putLong(surfaceData.getNativeOps());
        buffer.putLong(surfaceData2.getNativeOps());
    }
    
    static void Blit(SurfaceData ref, SurfaceData surfaceData, Composite comp, Region clip, AffineTransform xform, int n, int n2, int n3, int n4, int n5, double n6, double n7, double n8, double n9, int n10, boolean b) {
        int flags = 0;
        if (ref.getTransparency() == 1) {
            flags |= 0x1;
        }
        OGLRenderQueue instance = OGLRenderQueue.getInstance();
        instance.lock();
        try {
            instance.addReference(ref);
            OGLSurfaceData oglSurfaceData = (OGLSurfaceData)surfaceData;
            if (b) {
                OGLContext.setScratchSurface(oglSurfaceData.getOGLGraphicsConfig());
            }
            else {
                BufferedContext.validateContext(oglSurfaceData, oglSurfaceData, clip, comp, xform, null, null, flags);
            }
            enqueueBlit(instance, ref, surfaceData, createPackedParams(false, b, false, xform != null, n, n10), n2, n3, n4, n5, n6, n7, n8, n9);
            instance.flushNow();
        }
        finally {
            instance.unlock();
        }
    }
    
    static void IsoBlit(SurfaceData surfaceData, SurfaceData surfaceData2, BufferedImage srcImg, BufferedImageOp bufferedImageOp, Composite comp, Region clip, AffineTransform xform, int n, int n2, int n3, int n4, int n5, double n6, double n7, double n8, double n9, boolean b) {
        int flags = 0;
        if (surfaceData.getTransparency() == 1) {
            flags |= 0x1;
        }
        OGLRenderQueue instance = OGLRenderQueue.getInstance();
        instance.lock();
        try {
            OGLSurfaceData srcData = (OGLSurfaceData)surfaceData;
            OGLSurfaceData oglSurfaceData = (OGLSurfaceData)surfaceData2;
            int type = srcData.getType();
            int n10;
            if (type == 3) {
                n10 = false;
            }
            else {
                n10 = true;
                if (type == 5) {
                }
                else {
                    oglSurfaceData = srcData;
                }
            }
            BufferedContext.validateContext(oglSurfaceData, oglSurfaceData, clip, comp, xform, null, null, flags);
            if (bufferedImageOp != null) {
                BufferedBufImgOps.enableBufImgOp(instance, srcData, srcImg, bufferedImageOp);
            }
            enqueueBlit(instance, surfaceData, surfaceData2, createPackedParams(true, b, (boolean)n10, xform != null, n, 0), n2, n3, n4, n5, n6, n7, n8, n9);
            if (bufferedImageOp != null) {
                BufferedBufImgOps.disableBufImgOp(instance, bufferedImageOp);
            }
            if (n10 && oglSurfaceData.isOnScreen()) {
                instance.flushNow();
            }
        }
        finally {
            instance.unlock();
        }
    }
}
